#include <Application.h>
#include <Messenger.h>
#include <Window.h>
#include <Entry.h>
#include <String.h>
#include <MessageRunner.h>

#include "Defs.h"
#include "FavoriteWindow.h"

#ifndef _FAVORITE_APP_

class FavoriteApp : public BApplication
{
public:
					FavoriteApp			(void);
					~FavoriteApp		(void);
	
	virtual void	ArgvReceived		(int32 argc, char **argv);
	virtual void	RefsReceived		(BMessage	*	a_message);
	virtual void	ReadyToRun			(void);
	virtual void	MessageReceived		(BMessage	*	a_message);
			void	DropReceived		(BMessage	*	a_message);
	virtual void	AboutRequested		(void);

private:

	status_t		ProcessRefs			(entry_ref * ref, bool do_convert);

	void			Launch				(const char * a_URL);
	void			Launch				(const char * a_app_sig, const char * a_URL);

	status_t		ReadSettings		(void);		
	status_t		SaveSettings		(BMessage * a_message);
	status_t		MakeSettingsFolder	(void);

	void			RegisterFavorite		(void);
	void			RegisterBookmark		(void);
	void			RemoveOldFavorite		(void);
	
	void			get_URL_apps			(void);
	void			get_URL_pref_apps		(void);
	void			set_URL_pref_app		(BMessage * a_message);		// called by menuitems
	
	void			get_fav_pref_apps		(void);
	void			get_book_pref_apps		(void);
	void			set_win_pref_apps		(void);
	void			onoff_fav_pref_app		(void);		// called by menuitems
	void			onoff_book_pref_app		(void);		// called by menuitems
	
	void			set_pref_app		(const char * a_mime_str, const char * a_app_str);
	
	void			mime_changed			(BMessage * a_message);

	void			ErrorMessage		(const char	*	a_text, int32 a_status);
	void			Help				(void);	

	void			LaunchClipboard		(void);
	void			Clipboard2Bookmark	(void);
	
	bool				m_got_refs;
	bool				m_got_argv;
	bool				m_do_handle_favorites;
	bool				m_do_handle_bookmarks;
	
	BRect				m_winframe;
	FavoriteWindow	*	m_window;
	
	BMimeType		*	m_mime;
	BMessageRunner	*	m_msg_runner;
	
	BString		file_app;
	BString		ftp_app;
	BString		http_app;
	BString		https_app;
	BString		rtsp_app;
	BString		telnet_app;
	BString		mailto_app;
};

#define _FAVORITE_APP_
#endif
