// FavoriteWindow.h
// (C) Jonas Sundström @ Kirilla.com

#include <MenuBar.h>
#include <Bitmap.h>
#include <Menu.h>
#include <MenuItem.h>

#include "Defs.h"
#include "IconMenu.h"

#ifndef __FAVORITE_WINDOW_H__
#define __FAVORITE_WINDOW_H__

class FavoriteWindow : public BWindow
{
public:
					FavoriteWindow		(BRect a_winframe);
					~FavoriteWindow		();
	virtual void	MessageReceived 	(BMessage * a_message);
	virtual bool	QuitRequested		();
			
private:
			void	Save				();
			
			void	set_URL_apps		(BMessage * a_message);
			void	add_URL_app			(BMenu * a_menu, BString * a_url, BString * a_app);
			
			void	set_URL_pref_apps	(BMessage * a_message);
			void	set_URL_pref_app	(BMenu * a_menu, BString * a_url, BString * a_app);
			
			void	DeskbarIconOnOff	(void);
			void 	ReplicantQuits		(void);
			
	
	BBox		*	topbox;
	
	BMenuBar	*	m_menubar;
	IconMenu	*	m_iconmenu;
	BBitmap		*	m_bitmap;
	
	BMenu		*	m_appmenu;
	BMenu		*	m_settingsmenu;

	BMenuItem	*	m_clipboarditem;
	BMenuItem	*	m_clip2bookitem;
	BMenuItem	*	m_openbookitem;
	
	BMenuItem	*	m_aboutitem;
	BMenuItem	*	m_quititem;
	BMenuItem	*	m_help_item;

	BMenuItem	*	m_handle_fav_item;
	BMenuItem	*	m_handle_book_item;

	BMenu		*	m_file_menu;
	BMenu		*	m_ftp_menu;
	BMenu		*	m_http_menu;
	BMenu		*	m_https_menu;
	BMenu		*	m_rtsp_menu;
	BMenu		*	m_telnet_menu;
	BMenu		*	m_mailto_menu;
	
	BMenuItem	*	m_replicant_item;

};

#endif

